STOFFListener Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
STOFFListener Class Referenceabstract

This class contains a virtual interface to all listener. More...

`#include <STOFFListener.hxx>`

Inheritance diagram for STOFFListener:

## Public Types
enum | Type { Graphic, Presentation, Spreadsheet, Text }
| the listener type More...
enum | BreakType { PageBreak =0, SoftPageBreak, ColumnBreak }
| the different break type More...

## Public Member Functions
virtual | ~STOFFListener ()
| destructor More...
virtual Type | getType () const =0
| returns the listener type More...
virtual bool | canWriteText () const =0
| returns true if we can add text data More...
virtual void | setDocumentLanguage (std::string locale)=0
| sets the documents language More...
virtual void | setDocumentMetaData (const librevenge::RVNGPropertyList &list)=0
| sets the document meta data More...
virtual void | startDocument ()=0
| starts the document More...
virtual bool | isDocumentStarted () const =0
| returns true if a document is opened More...
virtual void | endDocument (bool sendDelayedSubDoc=true)=0
| ends the document More...
virtual bool | isPageSpanOpened () const =0
| returns true if a page is opened More...
virtual STOFFPageSpan const & | getPageSpan ()=0
| returns the current page span More...
virtual bool | openHeader (librevenge::RVNGPropertyList const &extras)=0
| open a header (interaction with STOFFPageSpan which fills the parameters for openHeader) More...
virtual bool | openFooter (librevenge::RVNGPropertyList const &extras)=0
| open a footer (interaction with STOFFPageSpan which fills the parameters for openFooter) More...
virtual bool | closeHeader ()=0
| close a header More...
virtual bool | closeFooter ()=0
| close a footer More...
virtual bool | insertHeaderRegion (STOFFSubDocumentPtr subDocument, librevenge::RVNGString const &which)=0
| insert a header More...
virtual bool | insertFooterRegion (STOFFSubDocumentPtr subDocument, librevenge::RVNGString const &which)=0
| insert a footer More...
virtual bool | isHeaderFooterOpened () const =0
| returns true if the header/footer is open More...
virtual void | insertChar (uint8_t character)=0
| adds a basic character, .. More...
virtual void | insertUnicode (uint32_t character)=0
| adds an unicode character. More...
virtual void | insertUnicodeList (std::vector< uint32_t > const &list)
| try to insert a list of unicode character More...
virtual void | insertUnicodeString (librevenge::RVNGString const &str)=0
| adds a unicode string More...
virtual void | insertTab ()=0
| adds a tab More...
virtual void | insertEOL (bool softBreak=false)=0
| adds an end of line ( by default an hard one) More...
virtual void | setFont (STOFFFont const &font)=0
| sets the font More...
virtual STOFFFont const & | getFont () const =0
| returns the actual font More...
virtual bool | isParagraphOpened () const =0
| returns true if a paragraph or a list is opened More...
virtual void | setParagraph (STOFFParagraph const &paragraph)=0
| sets the paragraph More...
virtual STOFFParagraph const & | getParagraph () const =0
| returns the actual paragraph More...
virtual void | defineStyle (STOFFGraphicStyle const &style)=0
| defines a graphic styles, return the graphic id More...
virtual bool | isGraphicStyleDefined (librevenge::RVNGString const &name) const =0
| check if a graphic style with a display name is already defined More...
virtual void | insertField (STOFFField const &field)=0
| adds a field type More...
virtual void | openLink (STOFFLink const &link)=0
| open a link More...
virtual void | closeLink ()=0
| close a link More...
virtual void | openTable (STOFFTable const &table)=0
| open a table More...
virtual void | closeTable ()=0
| closes this table More...
virtual void | openTableRow (float h, librevenge::RVNGUnit unit, bool headerRow=false)=0
| open a row with given height ( if h < 0.0, set min-row-height = -h ) More...
virtual void | closeTableRow ()=0
| closes this row More...
virtual void | openTableCell (STOFFCell const &cell)=0
| open a cell More...
virtual void | closeTableCell ()=0
| close a cell More...
virtual void | addEmptyTableCell (STOFFVec2i const &pos, STOFFVec2i span=STOFFVec2i(1, 1))=0
| add empty cell More...
virtual bool | canOpenSectionAddBreak () const =0
| returns true if we can add open a section, add page break, ... More...
virtual bool | isSectionOpened () const =0
| returns true if a section is opened More...
virtual STOFFSection const & | getSection () const =0
| returns the actual section More...
virtual bool | openSection (STOFFSection const &section)=0
| open a section if possible More...
virtual bool | closeSection ()=0
| close a section More...
virtual void | insertBreak (BreakType breakType)=0
| inserts a break type: ColumBreak, PageBreak, .. More...
virtual void | insertNote (STOFFNote const &note, STOFFSubDocumentPtr &subDocument)=0
| insert a note More...
virtual void | insertComment (STOFFSubDocumentPtr &subDocument, librevenge::RVNGString const &creator="", librevenge::RVNGString const &date="")=0
| adds comment More...
virtual void | insertPicture (STOFFPosition const &pos, STOFFEmbeddedObject const &picture, STOFFGraphicStyle const &style=STOFFGraphicStyle())=0
| adds a picture with various representationin given position. More...
virtual void | insertShape (STOFFGraphicShape const &shape, STOFFGraphicStyle const &style)=0
| adds a shape picture in given position More...
virtual void | insertTextBox (STOFFPosition const &pos, STOFFSubDocumentPtr subDocument, STOFFGraphicStyle const &frameStyle=STOFFGraphicStyle())=0
| adds a textbox in given position More...
virtual bool | openFrame (STOFFPosition const &pos, STOFFGraphicStyle const &style=STOFFGraphicStyle())=0
| low level: tries to open a frame More...
virtual void | closeFrame ()=0
| low level: tries to close the last opened frame More...
virtual bool | openGroup ()=0
| low level: tries to open a group More...
virtual void | closeGroup ()=0
| low level: tries to close the last opened group More...
virtual void | handleSubDocument (STOFFSubDocumentPtr subDocument, libstoff::SubDocumentType subDocumentType)=0
| low level: function called to add a subdocument More...
virtual bool | isSubDocumentOpened (libstoff::SubDocumentType &subdocType) const =0
| returns true if a subdocument is open More...

## Detailed Description

This class contains a virtual interface to all listener.

## Member Enumeration Documentation

enum STOFFListener::BreakType

the different break type

Enumerator
PageBreak |
SoftPageBreak |
ColumnBreak |

enum STOFFListener::Type

the listener type

Enumerator
Graphic |
Presentation |
Spreadsheet |
Text |

## Constructor & Destructor Documentation

virtual STOFFListener::~STOFFListener | ( |  | ) |
| inlinevirtual

destructor

## Member Function Documentation

virtual void STOFFListener::addEmptyTableCell | ( | STOFFVec2i const & | pos,
|  | STOFFVec2i | span = `STOFFVec2i(1, 1)`
| ) |  |
| pure virtual

add empty cell

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::canOpenSectionAddBreak | ( |  | ) | const
| pure virtual

returns true if we can add open a section, add page break, ...

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::canWriteText | ( |  | ) | const
| pure virtual

returns true if we can add text data

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::closeFooter | ( |  | ) |
| pure virtual

close a footer

Implemented in STOFFGraphicListener, and STOFFSpreadsheetListener.

Referenced by STOFFPageSpan::sendHeaderFooters().

virtual void STOFFListener::closeFrame | ( |  | ) |
| pure virtual

low level: tries to close the last opened frame

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::closeGroup | ( |  | ) |
| pure virtual

low level: tries to close the last opened group

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::closeHeader | ( |  | ) |
| pure virtual

close a header

Implemented in STOFFGraphicListener, and STOFFSpreadsheetListener.

Referenced by STOFFPageSpan::sendHeaderFooters().

virtual void STOFFListener::closeLink | ( |  | ) |
| pure virtual

close a link

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::closeSection | ( |  | ) |
| pure virtual

close a section

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::closeTable | ( |  | ) |
| pure virtual

closes this table

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::closeTableCell | ( |  | ) |
| pure virtual

close a cell

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::closeTableRow | ( |  | ) |
| pure virtual

closes this row

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::defineStyle | ( | STOFFGraphicStyle const & | style | ) |
| pure virtual

defines a graphic styles, return the graphic id

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::endDocument | ( | bool | sendDelayedSubDoc = `true` | ) |
| pure virtual

ends the document

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

virtual STOFFFont const& STOFFListener::getFont | ( |  | ) | const
| pure virtual

returns the actual font

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual STOFFPageSpan const& STOFFListener::getPageSpan | ( |  | ) |
| pure virtual

returns the current page span

Note
  this forces the opening of a new page if no page is opened.

Implemented in STOFFGraphicListener, and STOFFSpreadsheetListener.

virtual STOFFParagraph const& STOFFListener::getParagraph | ( |  | ) | const
| pure virtual

returns the actual paragraph

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual STOFFSection const& STOFFListener::getSection | ( |  | ) | const
| pure virtual

returns the actual section

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual Type STOFFListener::getType | ( |  | ) | const
| pure virtual

returns the listener type

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

virtual void STOFFListener::handleSubDocument | ( | STOFFSubDocumentPtr | subDocument,
|  | libstoff::SubDocumentType | subDocumentType
| ) |  |
| pure virtual

low level: function called to add a subdocument

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::insertBreak | ( | BreakType | breakType | ) |
| pure virtual

inserts a break type: ColumBreak, PageBreak, ..

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::insertChar | ( | uint8_t | character | ) |
| pure virtual

adds a basic character, ..

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

virtual void STOFFListener::insertComment | ( | STOFFSubDocumentPtr & | subDocument,
|  | librevenge::RVNGString const & | creator = `""`,
|  | librevenge::RVNGString const & | date = `""`
| ) |  |
| pure virtual

adds comment

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::insertEOL | ( | bool | softBreak = `false` | ) |
| pure virtual

adds an end of line ( by default an hard one)

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::insertField | ( | STOFFField const & | field | ) |
| pure virtual

adds a field type

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::insertFooterRegion | ( | STOFFSubDocumentPtr | subDocument,
|  | librevenge::RVNGString const & | which
| ) |  |
| pure virtual

insert a footer

Implemented in STOFFGraphicListener, and STOFFSpreadsheetListener.

Referenced by STOFFHeaderFooter::send().

virtual bool STOFFListener::insertHeaderRegion | ( | STOFFSubDocumentPtr | subDocument,
|  | librevenge::RVNGString const & | which
| ) |  |
| pure virtual

insert a header

Implemented in STOFFGraphicListener, and STOFFSpreadsheetListener.

Referenced by STOFFHeaderFooter::send().

virtual void STOFFListener::insertNote | ( | STOFFNote const & | note,
|  | STOFFSubDocumentPtr & | subDocument
| ) |  |
| pure virtual

insert a note

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::insertPicture | ( | STOFFPosition const & | pos,
|  | STOFFEmbeddedObject const & | picture,
|  | STOFFGraphicStyle const & | style = `STOFFGraphicStyle()`
| ) |  |
| pure virtual

adds a picture with various representationin given position.

Note
  by default only send the first picture

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::insertShape | ( | STOFFGraphicShape const & | shape,
|  | STOFFGraphicStyle const & | style
| ) |  |
| pure virtual

adds a shape picture in given position

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::insertTab | ( |  | ) |
| pure virtual

adds a tab

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::insertTextBox | ( | STOFFPosition const & | pos,
|  | STOFFSubDocumentPtr | subDocument,
|  | STOFFGraphicStyle const & | frameStyle = `STOFFGraphicStyle()`
| ) |  |
| pure virtual

adds a textbox in given position

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::insertUnicode | ( | uint32_t | character | ) |
| pure virtual

adds an unicode character.

By convention if character=0xfffd(undef), no character is added

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::insertUnicodeList | ( | std::vector< uint32_t > const & | list | ) |
| inlinevirtual

try to insert a list of unicode character

virtual void STOFFListener::insertUnicodeString | ( | librevenge::RVNGString const & | str | ) |
| pure virtual

adds a unicode string

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::isDocumentStarted | ( |  | ) | const
| pure virtual

returns true if a document is opened

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

virtual bool STOFFListener::isGraphicStyleDefined | ( | librevenge::RVNGString const & | name | ) | const
| pure virtual

check if a graphic style with a display name is already defined

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::isHeaderFooterOpened | ( |  | ) | const
| pure virtual

returns true if the header/footer is open

Implemented in STOFFGraphicListener, and STOFFSpreadsheetListener.

virtual bool STOFFListener::isPageSpanOpened | ( |  | ) | const
| pure virtual

returns true if a page is opened

Implemented in STOFFGraphicListener, and STOFFSpreadsheetListener.

virtual bool STOFFListener::isParagraphOpened | ( |  | ) | const
| pure virtual

returns true if a paragraph or a list is opened

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::isSectionOpened | ( |  | ) | const
| pure virtual

returns true if a section is opened

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::isSubDocumentOpened | ( | libstoff::SubDocumentType & | subdocType | ) | const
| pure virtual

returns true if a subdocument is open

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::openFooter | ( | librevenge::RVNGPropertyList const & | extras | ) |
| pure virtual

open a footer (interaction with STOFFPageSpan which fills the parameters for openFooter)

Implemented in STOFFGraphicListener, and STOFFSpreadsheetListener.

Referenced by STOFFPageSpan::sendHeaderFooters().

virtual bool STOFFListener::openFrame | ( | STOFFPosition const & | pos,
|  | STOFFGraphicStyle const & | style = `STOFFGraphicStyle()`
| ) |  |
| pure virtual

low level: tries to open a frame

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::openGroup | ( |  | ) |
| pure virtual

low level: tries to open a group

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::openHeader | ( | librevenge::RVNGPropertyList const & | extras | ) |
| pure virtual

open a header (interaction with STOFFPageSpan which fills the parameters for openHeader)

Implemented in STOFFGraphicListener, and STOFFSpreadsheetListener.

Referenced by STOFFPageSpan::sendHeaderFooters().

virtual void STOFFListener::openLink | ( | STOFFLink const & | link | ) |
| pure virtual

open a link

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual bool STOFFListener::openSection | ( | STOFFSection const & | section | ) |
| pure virtual

open a section if possible

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::openTable | ( | STOFFTable const & | table | ) |
| pure virtual

open a table

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::openTableCell | ( | STOFFCell const & | cell | ) |
| pure virtual

open a cell

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::openTableRow | ( | float | h,
|  | librevenge::RVNGUnit | unit,
|  | bool | headerRow = `false`
| ) |  |
| pure virtual

open a row with given height ( if h < 0.0, set min-row-height = -h )

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::setDocumentLanguage | ( | std::string | locale | ) |
| pure virtual

sets the documents language

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

virtual void STOFFListener::setDocumentMetaData | ( | const librevenge::RVNGPropertyList & | list | ) |
| pure virtual

sets the document meta data

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

virtual void STOFFListener::setFont | ( | STOFFFont const & | font | ) |
| pure virtual

sets the font

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::setParagraph | ( | STOFFParagraph const & | paragraph | ) |
| pure virtual

sets the paragraph

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

Referenced by insertUnicodeList().

virtual void STOFFListener::startDocument | ( |  | ) |
| pure virtual

starts the document

Implemented in STOFFSpreadsheetListener, and STOFFGraphicListener.

The documentation for this class was generated from the following file:

- STOFFListener.hxx